# Alumni Verification
We are an old Society (1992-<span id="year">now</span>) with a long history of members staying members long after they leave UL.  
In 2023 we had an outage ([see here for more information][outage_2023]) which lead to us loosing contact with many of these since their contact details were their Skynet email.    
We are also required to ensure that all active Skynet accounts are linked to a UL Computer Society membership.  
This put us in the catch22, where folks needed their Skynet account in order to gain access to their Skynet account.  

Many of these people want to regain access to their accounts and will make a request for help.

## How to process Requests
These requests to gain access to an old Skynet account may come in through one of our Email addresses (``contact@skynet.ie``) or from our [Discord][discord]

### Email
Keep an eye on the inboxes ye have access to.  
Ensure that you have set up the aliases correctly (TODO: Email Aliases).  
Aside from that be polite.

### Discord
Generally users will bring up their query in ``help-and-support``.  
It is recommended that you create a Private thread and ping them to bring them into it.  
This ensures that no private information will leak out.

#### How to create a Private Thread

1. Bottom left there is a Plus icon, click on that and select the ``Thread`` option.  
   ![plus_icon.png](alumni_verify/plus_icon.png)
2. In teh segment that popped up tick the Private Thread checkbox.  
   ![private_thread.png](alumni_verify/private_thread.png)

## The user recovers their own account.
The easiest way is that the user can recover their own account.  
This works if they know their own username/password.  
See [Account Recovery here][account_recovery] for more details.

If the user's account is old enough that the password is hashed with CRYPT then tehy will be unable to reset it themselves (even if they know teh password).  
This is due to CRYPT being specific to the *machine* it is on, and the LDAP server has moved several times since in the last two decades.  
In which case check out the following methods.

## Check if there is ``.forward``
A ``.forward`` file was placed in a users home directory to forward all incoming mail to that address.  

```shell
USER="username"

# Output a list of paths if one exists for this user
find  /skynet_old/{mailconfig,home}/$USER-name '.forward'

# use cat to output the contents to teh terminal
cat /skynet_old/mailconfig/$USER/.forward
```

### Usernames
One possible contents of the file is one or more Skynet usernames.

These are not too useful for our use case. 
```
usera
userb
```

### Email(s)
What we are looking for is an email (identity) to tie the Skynet account to.  
In which case you can check with the user that they still have access to teh email.  
Get them to send you a mail from that account and verify the headers (TODO: Email headers)
```
username@example.com
```

## Find a link to Personal Email
Nothing in the ``.forwards`` or they no longer have access to the email its time to see if you can tie their current identity to skynet.  
This is mostly possible since many members used to send mail between their Skynet account and their private account.

SSH into ``skynet.skynet.ie`` and run:
```shell
EMAIL="email@example.ie"
USER="username"
grep -r "$EMAIL" /skynet_old/{home,mail,mailconfig}/$USER
```
It may take a while to run depending on the contents of these folders.  
in some cases they may have proof of their ID, in which case you can search for that.

Honestly the output of this is vibes based.  
If there are forwarded email headers its a strong indication.  
If a file in their ``public_html`` shows up that is also a strong indication.  
The easiest one is if nothing pops up.

Remember you are the guardian of data on Skynet, if a user cannot prove a connection you are not obligated to grant them access.

[outage_2023]: ../support/recovery.md
[discord]: https://discord.skynet.ie
[account_recovery]: ../../support/recovery#account-recovery

<script>
  /* I am a lazy fucker */
  document.getElementById('year').textContent = new Date().getFullYear().toString()
</script>