# Change Committee Members
This page covers the adding and removing of UL Computer Society committee members.  

## Adding
Before starting the committee member in question *must* have a Skynet Account.   
This is because we have several services that require authentication to access.  
Details on how to create one can be found [here][skynet_account_creation].  

Once they have an account add their username to [``config/users.nix``][users.nix].  
Then commit and push.

Once everything is deployed they should have access to all resources within 15 min.
If you require it sooner than that see the [Force Update](#force-update) section below.

Next checkout the page on [VaultWarden](vaultwarden.md) to add the user to the password manager.

## Removing
Removing is essentially the same as adding.

Remove their username to [``config/users.nix``][users.nix].  
Then commit and push.

## Force Update
If you need to hasten an update you can log into teh server to give it a (virtual) kick.

### SSH into Kitt  
Kit is teh home of the user accounts.
```shell
ssh root@kitt.skynet.ie
```
### Once attached run these commands  
```shell
# reboot the main process
systemctl reboot skynet_ldap_backend.service

# Update the data (this ensures that folks are current members)
systemctl reboot skynet_ldap_backend-update_data.service

# Apply the new group roles
systemctl reboot skynet_ldap_backend-update_groups.service
```
### Exit the terminal.  
```shell
quit
```

[skynet_account_creation]: ../tutorials/skynet/create_account.md
[users.nix]: https://forgejo.skynet.ie/Skynet/nixos/src/branch/main/config/users.nix#L52